/*
    Copyright (C) 2002 Kjetil S. Matheussen / Notam.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include <stdlib.h>

#include <vstserver.h>

#include "clienthandler.h"
#include "mainhandler.h"



int MAINHANDLER_control(void *wws,char *argline_org){
  struct VSTClient *vstclient;


  char argline[1024];

  char *client_control_id_char=NULL;
  char *client_process_id_char=NULL;
  char *client_libname=NULL;

  int lokke=0;



  /**************************************************************************************/
  /************ Gather client control id, process id, and library name. *****************/
  /**************************************************************************************/

  sprintf(argline,"%s",argline_org);

  while(argline[lokke]!=' '){
    if(argline[lokke]==0){
      fprintf(stderr,"MAINHANDLER/control: Malformed argumentline for vstclientservant.\n");
      return 1;
    }
    lokke++;
  }

  if(lokke==0){
    fprintf(stderr,"MAINHANDLER/control: Malformed argumentline for vstclientservant.\n");
    return 2;
  }

  argline[lokke]=0;
  client_control_id_char=&argline[0];
  client_process_id_char=&argline[lokke+1];

  lokke++;

  while(argline[lokke]!=' '){
    if(argline[lokke]==0){
      fprintf(stderr,"MAINHANDLER/control: Malformed argumentline for vstclientservant.\n");
      return 3;
    }
    lokke++;
  }

  argline[lokke]=0;
  client_libname=&argline[lokke+1];



  /**************************************************************************************/
  /************************** Trying to serve new client. *******************************/
  /**************************************************************************************/

  vstclient=CH_new(
		   wws,
		   atoi(client_control_id_char),
		   atoi(client_process_id_char),
		   client_libname
		   );

  if(vstclient!=NULL){
    int rec;

    printf("VSTSERVER_clientthread: %s started.\n",client_libname);

    if(C_receive(vstclient->newdelete_input,&rec,sizeof(int))==0){
      fprintf(stderr,"VSTSERVER/VSTSERVER_clientthread: Seems like client has died. Exiting.\n");
    }

    CH_delete(vstclient);
    printf("VSTSERVER_clientthread: %s stopped.\n",client_libname);
  }

  return 0;
}


